// paramspecial.h
// LiVES
// (c) G. Finch 2004 <salsaman@xs4all.nl>
// released under the GNU GPL 2
// see file ../COPYING or www.gnu.org for licensing details


// dynamic window generation from parameter arrays :-)
// special widgets


typedef struct {
  gint height_param;
  gint width_param;
  GtkWidget *height_widget;
  GtkWidget *width_widget;
  GtkWidget *checkbutton;
  gulong width_func;
  gulong height_func;
} lives_special_aspect_t;


typedef struct {
  gboolean added;
  gint type;
  gint xstart_param;
  gint ystart_param;
  gint xend_param;
  gint yend_param;
  GtkWidget *xstart_widget;
  GtkWidget *ystart_widget;
  GtkWidget *xend_widget;
  GtkWidget *yend_widget;
} lives_special_framedraw_rect_t;

#define FD_RECT_DEMASK 1

typedef struct {
  gint start_param;
  gint end_param;
  GtkWidget *start_widget;
  GtkWidget *end_widget;
  lives_rendered_effect_t *rfx;
} lives_special_mergealign_t;
////////////////////////////////

void init_special (void);

gint add_to_special (gchar *special_string, lives_rendered_effect_t *);

void check_for_special (lives_param_t *param, gint num, GtkBox *parent_box);

void after_aspect_width_changed (GtkSpinButton *, gpointer);

void after_aspect_height_changed (GtkToggleButton *, gpointer);

void special_cleanup (void);

lives_special_mergealign_t mergealign;
void setmergealign (void);

#include "framedraw.h"

#define RFX_EXTRA_WIDTH 200 /* extra width in pixels for framedraw */
