// paramwindow.h
// LiVES
// (c) G. Finch 2004 <salsaman@xs4all.nl>
// released under the GNU GPL 2
// see file COPYING or www.gnu.org for licensing details


typedef struct {
  gint usr_number;
  GSList *rbgroup;
  gint active_param;
} lives_widget_group_t;


#define RFX_TEXT_MAGIC 80
#define RFX_DEF_NUM_MAX 1000000

#define RFX_WINSIZE_H 600
#define RFX_WINSIZE_V 400

#define DEF_BUTTON_WIDTH 80

void on_paramwindow_ok_clicked (GtkButton *, lives_rendered_effect_t *);
void on_paramwindow_cancel_clicked (GtkButton *, lives_rendered_effect_t *);
void on_paramwindow_cancel_clicked2 (GtkButton *, lives_rendered_effect_t *);

void on_render_fx_pre_activate (GtkMenuItem *, lives_rendered_effect_t *);
void on_render_fx_activate (GtkMenuItem *, lives_rendered_effect_t *);

void make_param_box(GtkVBox *, lives_rendered_effect_t *);

void add_param_to_box (GtkBox *, lives_rendered_effect_t *, gint param_number, GtkTooltips *tooltips);
void add_hsep_to_box (GtkBox *);
void add_fill_to_box (GtkBox *);
void add_label_to_box (GtkBox *, const gchar *text);

GSList *add_usrgrp_to_livesgrp (GSList *u2l, GSList *rbgroup, gint usr_number);
lives_widget_group_t *livesgrp_from_usrgrp (GSList *u2l, gint usrgrp);

void after_boolean_param_toggled (GtkToggleButton *, lives_rendered_effect_t * rfx);
void after_param_value_changed (GtkSpinButton *, lives_rendered_effect_t * rfx);
void after_param_red_changed (GtkSpinButton *, lives_rendered_effect_t * rfx);
void after_param_green_changed (GtkSpinButton *, lives_rendered_effect_t * rfx);
void after_param_blue_changed (GtkSpinButton *, lives_rendered_effect_t * rfx);
void after_param_alpha_changed (GtkSpinButton *, lives_rendered_effect_t * rfx);
void after_param_text_changed (GtkWidget *, lives_rendered_effect_t *rfx);
void after_string_list_changed (GtkEntry *, lives_rendered_effect_t *rfx);

void on_pwcolourbutton_clicked (GtkButton *button, lives_rendered_effect_t *);
void on_pwcolsel_ok_clicked (GtkButton *button, lives_rendered_effect_t *);
void on_pwcolsel_cancel_clicked (GtkButton *button, gpointer unused);

gchar *param_marshall (lives_rendered_effect_t *rfx, gboolean with_min_max);
void param_demarshall (lives_rendered_effect_t *rfx, GList *plist, gboolean update_widgets);
gint set_param_from_list(GList *plist, lives_param_t *param, gint pnum, gboolean upd);

void widget_act_toggle (GtkWidget *, GtkToggleButton *);
gboolean label_act_toggle (GtkWidget *, GdkEventButton *, GtkToggleButton *);

void toggle_set_default_value (GtkToggleButton *, GtkSpinButton *);
void toggle_set_default_red (GtkToggleButton *, GtkSpinButton *);
void toggle_set_default_green (GtkToggleButton *, GtkSpinButton *);
void toggle_set_default_blue (GtkToggleButton *, GtkSpinButton *);
void toggle_set_default_alpha (GtkToggleButton *, GtkSpinButton *);
void toggle_set_default_text (GtkToggleButton *button, GtkWidget *textwidget);
void toggle_set_default_combo (GtkToggleButton *button, GtkCombo *combo);

// object should have g_set_object_data "param_number" set to parameter number
// (1 based, -ve for init onchanges)
void do_onchange (GObject *object, lives_rendered_effect_t *);



