// preferences.h
// LiVES (lives-exe)
// (c) G. Finch 2004
// released under the GNU GPL 2
// see file ../COPYING or www.gnu.org for licensing details

#ifndef _HAS_PREFS_H
#define _HAS_PREFS_H

typedef struct {
  gchar bgcolour[256];
  gboolean stop_screensaver;
  gboolean open_maximised;
  gchar theme[64];  // the theme name

  gshort pb_quality;
#define PB_QUALITY_LOW 1
#define PB_QUALITY_MED 2  // default
#define PB_QUALITY_HIGH 3

  _encoder encoder;

  gshort audio_player;
#define AUD_PLAYER_SOX 1
#define AUD_PLAYER_MPLAYER 2

  // frame quantisation type
  gshort q_type;
#define Q_FILL 1
#define Q_SMOOTH 1

  gchar tmpdir[256];

  // TODO - also use cur_vid_load_dir, etc.
  gchar def_vid_load_dir[256];
  gchar def_vid_save_dir[256];
  gchar def_audio_dir[256];
  gchar def_image_dir[256];
  gchar def_proj_dir[256];

  gchar prefix_dir[256];
  gchar image_ext[16];

  unsigned int warning_mask;
  // if these bits are set, we do not show the warning
#define WARN_MASK_FPS 1<<0
#define WARN_MASK_FSIZE 1<<1
#define WARN_MASK_SAVE_QUALITY 1<<2
#define WARN_MASK_SAVE_SET 1<<3
#define WARN_MASK_NO_MPLAYER 1<<4

  gchar effect_command[256];
  gchar video_play_command[256];
  gchar video_open_command[256];
  gchar audio_play_command[256];
  gchar cdplay_device[256];
  gdouble default_fps;
  gint bar_height;
  gboolean pause_effect_during_preview;
  gboolean open_decorated;
  int sleep_time;
  gboolean pause_during_pb;
  gboolean fileselmax;
  gboolean show_recent;
  gint warn_file_size;
  gboolean pause_xmms;
  gboolean midisynch;
  gint dl_bandwidth;
  gboolean conserve_space;
  gboolean ins_resample;
  gboolean show_tool;
  gshort sepwin_type;
  gboolean show_player_stats;
  gboolean show_framecount;
  gint default_height;
  gint default_width;
  gboolean loop_recording;
  gboolean discard_tv;
  gboolean save_directories;
  guint max_record_frames;
  gboolean safer_preview;
  gint rec_opts;
#define REC_FRAMES (1<<0)
#define REC_FPS (1<<1)
#define REC_EFFECTS (1<<2)
#define REC_CLIPS (1<<3)

  gboolean debug_encoders;
  gboolean no_bandwidth;
  gboolean osc_udp_started;
  guint osc_udp_port;
#define OSC_DEFAULT_UDP_PORT 9999


#ifdef ENABLE_OSC
  gboolean omc_noisy;
#endif

  gshort firsttime;
  const gchar *wm; //window manager name
  gint ocp; // open_compression_percent : get/set in prefs

  // whether the 'blend_file' (second file in a transition) is fg or bg
  gboolean antialias;

  // TODO - move into mainw, make space there first
  gint reorder_width;
  gint reorder_height;
  gboolean reorder_leave_back;

  gboolean ignore_tiny_fps_diffs;

  gshort rfx_keys_virtual;

  gshort jack_transport_state;
#define JACK_TRANSPORT_STATE_CLIENT (1<<0)
#define JACK_TRANSPORT_STATE_MASTER (1<<1)

} _prefs;



typedef struct {
  gchar tmpdir[256];
  gchar theme[64];
  gchar vpp_name[64]; // new video playback plugin
  _encoder encoder;
  gboolean show_recent;
  gboolean show_tool;
  guint osc_udp_port;
} _future_prefs;

_prefs *prefs;
_future_prefs *future_prefs;
_prefsw *prefsw;


void set_acodec_list_from_allowed (_prefsw *);

_prefsw* create_prefs_dialog (void);

gboolean on_prefs_delete_event (GtkWidget *, GdkEvent *, gpointer);

void on_preferences_activate (GtkMenuItem *, gpointer);

void on_prefs_ok_clicked (GtkButton *, gpointer);

#endif
