// resample.h
// LiVES
// (c) G. Finch 2004 <salsaman@xs4all.nl>
// released under the GNU GPL 2
// see file ../COPYING or www.gnu.org for licensing details


// functions/structs for reordering, resampling video and audio

#ifndef __HAS_RESAMPLE_H
#define __HAS_RESAMPLE_H


typedef struct __resaudw {
  // resample audio window
  GtkWidget *dialog;
  GtkWidget *entry_arate;
  GtkWidget *entry_achans;
  GtkWidget *entry_asamps;
  GtkWidget *rb_signed;
  GtkWidget *rb_unsigned;
  GtkWidget *rb_bigend;
  GtkWidget *rb_littleend;
} _resaudw;


_resaudw *resaudw;


// main quantisation functions
inline gint64 q_gint64 (gint64 in, gdouble fps);
inline gint64 q_dbl (gdouble in, gdouble fps);

event_list_t *quantise_events (event_list_t *in_list, gdouble new_fps, gboolean allow_gap); // quantise frame events for a single clip

///////////////////////////////////////////////////////
inline gint count_resampled_frames (gint in_frames, gdouble orig_fps, gdouble resampled_fps);

/////////////////////////////////////////

// GUI functions
// window change speed from Tools menu
GtkWidget* create_new_pb_speed (gshort type);

// resample audio window
_resaudw* create_resaudw (gshort type);
// type 1 : show current and new
// type 2 : show new

void on_change_speed_activate (GtkMenuItem *, gpointer);
void on_change_speed_ok_clicked (GtkButton *, gpointer);

gboolean auto_resample_resize (gint width,gint height,gdouble fps,gint fps_num,gint fps_denom, gint arate);
gint reorder_frames(void);
gint deorder_frames(gint old_framecount);


#endif
